package cn.superdesk.uniorder.dao.entity.sys.role;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class SysRoleExtDataExample {
    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    protected String orderByClause;

    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    protected boolean distinct;

    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    protected List<Criteria> oredCriteria;

    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    public SysRoleExtDataExample() {
        oredCriteria = new ArrayList<>();
    }

    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    public String getOrderByClause() {
        return orderByClause;
    }

    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    public boolean isDistinct() {
        return distinct;
    }

    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andServiceNoMultIsNull() {
            addCriterion("service_no_mult is null");
            return (Criteria) this;
        }

        public Criteria andServiceNoMultIsNotNull() {
            addCriterion("service_no_mult is not null");
            return (Criteria) this;
        }

        public Criteria andServiceNoMultEqualTo(String value) {
            addCriterion("service_no_mult =", value, "serviceNoMult");
            return (Criteria) this;
        }

        public Criteria andServiceNoMultNotEqualTo(String value) {
            addCriterion("service_no_mult <>", value, "serviceNoMult");
            return (Criteria) this;
        }

        public Criteria andServiceNoMultGreaterThan(String value) {
            addCriterion("service_no_mult >", value, "serviceNoMult");
            return (Criteria) this;
        }

        public Criteria andServiceNoMultGreaterThanOrEqualTo(String value) {
            addCriterion("service_no_mult >=", value, "serviceNoMult");
            return (Criteria) this;
        }

        public Criteria andServiceNoMultLessThan(String value) {
            addCriterion("service_no_mult <", value, "serviceNoMult");
            return (Criteria) this;
        }

        public Criteria andServiceNoMultLessThanOrEqualTo(String value) {
            addCriterion("service_no_mult <=", value, "serviceNoMult");
            return (Criteria) this;
        }

        public Criteria andServiceNoMultLike(String value) {
            addCriterion("service_no_mult like", value, "serviceNoMult");
            return (Criteria) this;
        }

        public Criteria andServiceNoMultNotLike(String value) {
            addCriterion("service_no_mult not like", value, "serviceNoMult");
            return (Criteria) this;
        }

        public Criteria andServiceNoMultIn(List<String> values) {
            addCriterion("service_no_mult in", values, "serviceNoMult");
            return (Criteria) this;
        }

        public Criteria andServiceNoMultNotIn(List<String> values) {
            addCriterion("service_no_mult not in", values, "serviceNoMult");
            return (Criteria) this;
        }

        public Criteria andServiceNoMultBetween(String value1, String value2) {
            addCriterion("service_no_mult between", value1, value2, "serviceNoMult");
            return (Criteria) this;
        }

        public Criteria andServiceNoMultNotBetween(String value1, String value2) {
            addCriterion("service_no_mult not between", value1, value2, "serviceNoMult");
            return (Criteria) this;
        }

        public Criteria andServiceNameMultIsNull() {
            addCriterion("service_name_mult is null");
            return (Criteria) this;
        }

        public Criteria andServiceNameMultIsNotNull() {
            addCriterion("service_name_mult is not null");
            return (Criteria) this;
        }

        public Criteria andServiceNameMultEqualTo(String value) {
            addCriterion("service_name_mult =", value, "serviceNameMult");
            return (Criteria) this;
        }

        public Criteria andServiceNameMultNotEqualTo(String value) {
            addCriterion("service_name_mult <>", value, "serviceNameMult");
            return (Criteria) this;
        }

        public Criteria andServiceNameMultGreaterThan(String value) {
            addCriterion("service_name_mult >", value, "serviceNameMult");
            return (Criteria) this;
        }

        public Criteria andServiceNameMultGreaterThanOrEqualTo(String value) {
            addCriterion("service_name_mult >=", value, "serviceNameMult");
            return (Criteria) this;
        }

        public Criteria andServiceNameMultLessThan(String value) {
            addCriterion("service_name_mult <", value, "serviceNameMult");
            return (Criteria) this;
        }

        public Criteria andServiceNameMultLessThanOrEqualTo(String value) {
            addCriterion("service_name_mult <=", value, "serviceNameMult");
            return (Criteria) this;
        }

        public Criteria andServiceNameMultLike(String value) {
            addCriterion("service_name_mult like", value, "serviceNameMult");
            return (Criteria) this;
        }

        public Criteria andServiceNameMultNotLike(String value) {
            addCriterion("service_name_mult not like", value, "serviceNameMult");
            return (Criteria) this;
        }

        public Criteria andServiceNameMultIn(List<String> values) {
            addCriterion("service_name_mult in", values, "serviceNameMult");
            return (Criteria) this;
        }

        public Criteria andServiceNameMultNotIn(List<String> values) {
            addCriterion("service_name_mult not in", values, "serviceNameMult");
            return (Criteria) this;
        }

        public Criteria andServiceNameMultBetween(String value1, String value2) {
            addCriterion("service_name_mult between", value1, value2, "serviceNameMult");
            return (Criteria) this;
        }

        public Criteria andServiceNameMultNotBetween(String value1, String value2) {
            addCriterion("service_name_mult not between", value1, value2, "serviceNameMult");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdsIsNull() {
            addCriterion("sys_role_ext_sample_ids is null");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdsIsNotNull() {
            addCriterion("sys_role_ext_sample_ids is not null");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdsEqualTo(String value) {
            addCriterion("sys_role_ext_sample_ids =", value, "sysRoleExtSampleIds");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdsNotEqualTo(String value) {
            addCriterion("sys_role_ext_sample_ids <>", value, "sysRoleExtSampleIds");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdsGreaterThan(String value) {
            addCriterion("sys_role_ext_sample_ids >", value, "sysRoleExtSampleIds");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdsGreaterThanOrEqualTo(String value) {
            addCriterion("sys_role_ext_sample_ids >=", value, "sysRoleExtSampleIds");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdsLessThan(String value) {
            addCriterion("sys_role_ext_sample_ids <", value, "sysRoleExtSampleIds");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdsLessThanOrEqualTo(String value) {
            addCriterion("sys_role_ext_sample_ids <=", value, "sysRoleExtSampleIds");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdsLike(String value) {
            addCriterion("sys_role_ext_sample_ids like", value, "sysRoleExtSampleIds");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdsNotLike(String value) {
            addCriterion("sys_role_ext_sample_ids not like", value, "sysRoleExtSampleIds");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdsIn(List<String> values) {
            addCriterion("sys_role_ext_sample_ids in", values, "sysRoleExtSampleIds");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdsNotIn(List<String> values) {
            addCriterion("sys_role_ext_sample_ids not in", values, "sysRoleExtSampleIds");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdsBetween(String value1, String value2) {
            addCriterion("sys_role_ext_sample_ids between", value1, value2, "sysRoleExtSampleIds");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdsNotBetween(String value1, String value2) {
            addCriterion("sys_role_ext_sample_ids not between", value1, value2, "sysRoleExtSampleIds");
            return (Criteria) this;
        }

        public Criteria andSourceFromIsNull() {
            addCriterion("source_from is null");
            return (Criteria) this;
        }

        public Criteria andSourceFromIsNotNull() {
            addCriterion("source_from is not null");
            return (Criteria) this;
        }

        public Criteria andSourceFromEqualTo(String value) {
            addCriterion("source_from =", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromNotEqualTo(String value) {
            addCriterion("source_from <>", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromGreaterThan(String value) {
            addCriterion("source_from >", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromGreaterThanOrEqualTo(String value) {
            addCriterion("source_from >=", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromLessThan(String value) {
            addCriterion("source_from <", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromLessThanOrEqualTo(String value) {
            addCriterion("source_from <=", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromLike(String value) {
            addCriterion("source_from like", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromNotLike(String value) {
            addCriterion("source_from not like", value, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromIn(List<String> values) {
            addCriterion("source_from in", values, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromNotIn(List<String> values) {
            addCriterion("source_from not in", values, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromBetween(String value1, String value2) {
            addCriterion("source_from between", value1, value2, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromNotBetween(String value1, String value2) {
            addCriterion("source_from not between", value1, value2, "sourceFrom");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdIsNull() {
            addCriterion("source_from_quote_id is null");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdIsNotNull() {
            addCriterion("source_from_quote_id is not null");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdEqualTo(Long value) {
            addCriterion("source_from_quote_id =", value, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdNotEqualTo(Long value) {
            addCriterion("source_from_quote_id <>", value, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdGreaterThan(Long value) {
            addCriterion("source_from_quote_id >", value, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdGreaterThanOrEqualTo(Long value) {
            addCriterion("source_from_quote_id >=", value, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdLessThan(Long value) {
            addCriterion("source_from_quote_id <", value, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdLessThanOrEqualTo(Long value) {
            addCriterion("source_from_quote_id <=", value, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdIn(List<Long> values) {
            addCriterion("source_from_quote_id in", values, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdNotIn(List<Long> values) {
            addCriterion("source_from_quote_id not in", values, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdBetween(Long value1, Long value2) {
            addCriterion("source_from_quote_id between", value1, value2, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andSourceFromQuoteIdNotBetween(Long value1, Long value2) {
            addCriterion("source_from_quote_id not between", value1, value2, "sourceFromQuoteId");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeIsNull() {
            addCriterion("permit_start_time is null");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeIsNotNull() {
            addCriterion("permit_start_time is not null");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeEqualTo(Date value) {
            addCriterion("permit_start_time =", value, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeNotEqualTo(Date value) {
            addCriterion("permit_start_time <>", value, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeGreaterThan(Date value) {
            addCriterion("permit_start_time >", value, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("permit_start_time >=", value, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeLessThan(Date value) {
            addCriterion("permit_start_time <", value, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeLessThanOrEqualTo(Date value) {
            addCriterion("permit_start_time <=", value, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeIn(List<Date> values) {
            addCriterion("permit_start_time in", values, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeNotIn(List<Date> values) {
            addCriterion("permit_start_time not in", values, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeBetween(Date value1, Date value2) {
            addCriterion("permit_start_time between", value1, value2, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitStartTimeNotBetween(Date value1, Date value2) {
            addCriterion("permit_start_time not between", value1, value2, "permitStartTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeIsNull() {
            addCriterion("permit_end_time is null");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeIsNotNull() {
            addCriterion("permit_end_time is not null");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeEqualTo(Date value) {
            addCriterion("permit_end_time =", value, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeNotEqualTo(Date value) {
            addCriterion("permit_end_time <>", value, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeGreaterThan(Date value) {
            addCriterion("permit_end_time >", value, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("permit_end_time >=", value, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeLessThan(Date value) {
            addCriterion("permit_end_time <", value, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeLessThanOrEqualTo(Date value) {
            addCriterion("permit_end_time <=", value, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeIn(List<Date> values) {
            addCriterion("permit_end_time in", values, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeNotIn(List<Date> values) {
            addCriterion("permit_end_time not in", values, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeBetween(Date value1, Date value2) {
            addCriterion("permit_end_time between", value1, value2, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andPermitEndTimeNotBetween(Date value1, Date value2) {
            addCriterion("permit_end_time not between", value1, value2, "permitEndTime");
            return (Criteria) this;
        }

        public Criteria andNameIsNull() {
            addCriterion("name is null");
            return (Criteria) this;
        }

        public Criteria andNameIsNotNull() {
            addCriterion("name is not null");
            return (Criteria) this;
        }

        public Criteria andNameEqualTo(String value) {
            addCriterion("name =", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotEqualTo(String value) {
            addCriterion("name <>", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameGreaterThan(String value) {
            addCriterion("name >", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameGreaterThanOrEqualTo(String value) {
            addCriterion("name >=", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLessThan(String value) {
            addCriterion("name <", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLessThanOrEqualTo(String value) {
            addCriterion("name <=", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLike(String value) {
            addCriterion("name like", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotLike(String value) {
            addCriterion("name not like", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameIn(List<String> values) {
            addCriterion("name in", values, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotIn(List<String> values) {
            addCriterion("name not in", values, "name");
            return (Criteria) this;
        }

        public Criteria andNameBetween(String value1, String value2) {
            addCriterion("name between", value1, value2, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotBetween(String value1, String value2) {
            addCriterion("name not between", value1, value2, "name");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("remark is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("remark is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("remark =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("remark <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("remark >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("remark >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("remark <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("remark <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("remark like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("remark not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("remark in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("remark not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("remark between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("remark not between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andEnabledIsNull() {
            addCriterion("enabled is null");
            return (Criteria) this;
        }

        public Criteria andEnabledIsNotNull() {
            addCriterion("enabled is not null");
            return (Criteria) this;
        }

        public Criteria andEnabledEqualTo(Integer value) {
            addCriterion("enabled =", value, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledNotEqualTo(Integer value) {
            addCriterion("enabled <>", value, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledGreaterThan(Integer value) {
            addCriterion("enabled >", value, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledGreaterThanOrEqualTo(Integer value) {
            addCriterion("enabled >=", value, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledLessThan(Integer value) {
            addCriterion("enabled <", value, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledLessThanOrEqualTo(Integer value) {
            addCriterion("enabled <=", value, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledIn(List<Integer> values) {
            addCriterion("enabled in", values, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledNotIn(List<Integer> values) {
            addCriterion("enabled not in", values, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledBetween(Integer value1, Integer value2) {
            addCriterion("enabled between", value1, value2, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledNotBetween(Integer value1, Integer value2) {
            addCriterion("enabled not between", value1, value2, "enabled");
            return (Criteria) this;
        }

        public Criteria andDeletedIsNull() {
            addCriterion("deleted is null");
            return (Criteria) this;
        }

        public Criteria andDeletedIsNotNull() {
            addCriterion("deleted is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedEqualTo(Integer value) {
            addCriterion("deleted =", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedNotEqualTo(Integer value) {
            addCriterion("deleted <>", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedGreaterThan(Integer value) {
            addCriterion("deleted >", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedGreaterThanOrEqualTo(Integer value) {
            addCriterion("deleted >=", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedLessThan(Integer value) {
            addCriterion("deleted <", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedLessThanOrEqualTo(Integer value) {
            addCriterion("deleted <=", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedIn(List<Integer> values) {
            addCriterion("deleted in", values, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedNotIn(List<Integer> values) {
            addCriterion("deleted not in", values, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedBetween(Integer value1, Integer value2) {
            addCriterion("deleted between", value1, value2, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedNotBetween(Integer value1, Integer value2) {
            addCriterion("deleted not between", value1, value2, "deleted");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNull() {
            addCriterion("create_user_id is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNotNull() {
            addCriterion("create_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdEqualTo(Long value) {
            addCriterion("create_user_id =", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotEqualTo(Long value) {
            addCriterion("create_user_id <>", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThan(Long value) {
            addCriterion("create_user_id >", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("create_user_id >=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThan(Long value) {
            addCriterion("create_user_id <", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("create_user_id <=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIn(List<Long> values) {
            addCriterion("create_user_id in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotIn(List<Long> values) {
            addCriterion("create_user_id not in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdBetween(Long value1, Long value2) {
            addCriterion("create_user_id between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("create_user_id not between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNull() {
            addCriterion("update_user_id is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNotNull() {
            addCriterion("update_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdEqualTo(Long value) {
            addCriterion("update_user_id =", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotEqualTo(Long value) {
            addCriterion("update_user_id <>", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThan(Long value) {
            addCriterion("update_user_id >", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("update_user_id >=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThan(Long value) {
            addCriterion("update_user_id <", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("update_user_id <=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIn(List<Long> values) {
            addCriterion("update_user_id in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotIn(List<Long> values) {
            addCriterion("update_user_id not in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdBetween(Long value1, Long value2) {
            addCriterion("update_user_id between", value1, value2, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("update_user_id not between", value1, value2, "updateUserId");
            return (Criteria) this;
        }
    }

    /**
     *
     * table sys_role_ext_data
     *
     * do_not_delete_during_merge Tue Sep 01 18:00:48 CST 2020
     */
    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    /**
     *
     * table sys_role_ext_data
     *
     * Tue Sep 01 18:00:48 CST 2020
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}